﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using System;
using UnityEngine.SceneManagement;
using System.Collections.Generic;

public class GameManager : MonoBehaviour {

	public GameObject playerPrefab;
	public Text continueText;
	public Text scoreText;

	public float currentScore = 0f;
	private float bestScore = 0f;
	private float blinkTime = 0f;
	private bool blink;
	private bool gameStarted;
	public int lives = 3;
	private TimeManager timeManager;
	private GameObject player;
	private GameObject floor;
	private Spawner spawner;
	private SpawnerLeft spawnerLeft;
	private bool beatBestScore = false;
	//private GameObjectUtil gameObjectUtil;

	void Awake(){
		floor = GameObject.Find ("Foreground");
		spawner = GameObject.Find ("Spawner").GetComponent<Spawner> ();
		spawnerLeft = GameObject.Find ("SpawnerLeft").GetComponent<SpawnerLeft> ();
		timeManager = GetComponent<TimeManager> ();
		//gameObjectUtil = GameObject.Find ("GameObjectUtil").GetComponent<GameObjectUtil> ();
	}

	// Use this for initialization
	void Start () {

		//gameObjectUtil.pools = new Dictionary<RecycleGameObject, ObjectPool> ();

		var floorHeight = floor.transform.localScale.y;

		var pos = floor.transform.position;
		pos.x = 0;
		pos.y = -((Screen.height / PixelPerfectCamera.pixelsToUnits) / 2) + (floorHeight / 2);
		floor.transform.position = pos;
		//pools = new Dictionary<RecycleGameObject, ObjectPool> ();

		spawner.active = true;
		spawnerLeft.active = true;

		//Time.timeScale = 0;

		//continueText.text = "PRESS ANY BUTTON TO START";

		bestScore = PlayerPrefs.GetFloat ("bestScore");
	}
	
	// Update is called once per frame
	void Update () {

		scoreText.text = "SCORE: " + currentScore;

		if (lives == 0)
		{
			spawner.active = false;
			spawnerLeft.active = false;
			Debug.Log("Game Over");
			OnPlayerKilled();
		}
		if (!gameStarted) {

			if(Input.GetKey (KeyCode.W)){
				//timeManager.ManipulateTime(1, 1f);
				ResetGame();
			}
		}

		//if (!gameStarted) {
			//blinkTime ++;

			//if (blinkTime % 40 == 0) {
			//	blink = !blink;
			//}
			//continueText.canvasRenderer.SetAlpha (blink ? 0 : 1);
			//var textColor = beatBestScore ? "#FF0" : "#FFF";
		 else {
			//currentScore += Time.deltaTime;
			scoreText.text = "SCORE: "+ currentScore;
		}
	}

	void OnPlayerKilled(){
		spawner.active = false;
		spawnerLeft.active = false;
		lives = 3;

		//var playerDestroyScript = player.GetComponent<DestroyOffscreen> ();
		//playerDestroyScript.DestroyCallback -= OnPlayerKilled;

		//player.GetComponent<Rigidbody2D> ().velocity = Vector2.zero;
		//timeManager.ManipulateTime (0, 5.5f);
		//gameStarted = false;
		PlayerPrefs.SetFloat("currentScore", currentScore);

		//continueText.text = "PRESS ANY BUTTON TO RESTART";

		if (currentScore > bestScore) {
			bestScore = currentScore;
			PlayerPrefs.SetFloat("bestScore", bestScore);
			beatBestScore = true;
		}

		SceneManager.LoadScene("gameover");
	}

	void ResetGame(){
		//spawner.active = true;
		//spawner.active = false;

		spawner.active = true;
		spawnerLeft.active = true;

		//player = GameObjectUtil.Instantiate(playerPrefab, new Vector3(0, (Screen.height/PixelPerfectCamera.pixelsToUnits)/2 + 100, 0));

		//var playerDestroyScript = player.GetComponent<DestroyOffscreen> ();
		//playerDestroyScript.DestroyCallback += OnPlayerKilled;

		gameStarted = true;

		//continueText.canvasRenderer.SetAlpha(0);

		currentScore = 0;
		beatBestScore = false;
	}

	string FormatTime(float value){
		TimeSpan t = TimeSpan.FromSeconds (value);

		return string.Format("{0:D2}:{1:D2}", t.Minutes, t.Seconds);
	}

}
