﻿using UnityEngine;
using System.Collections;

public class Obstacle : MonoBehaviour, IRecyle {

	public Sprite[] sprites;
	//public Vector2 colliderOffset = Vector2.zero;
	private Rigidbody2D body2d;

	public float moveSpeedX;
	public float moveSpeedY;
	public float blastSpeedX = 0f;
	public float blastSpeedY = 0f;
	public float blastX;
	public float blastY;
	public float blastUpY;
	public GameManager gameManager;
	public SuperCharged superChargedScript;
	public PlayerController playerControlScript;
	AudioSource ghostWoo;

	void Awake () {
	body2d = GetComponent<Rigidbody2D> ();
	transform.DetachChildren();
	//gameManager = GameObject.Find ("GameManager").GetComponent<GameManager> ();
	}

	void Start(){

				 foreach (Transform child in transform) {
     GameObject.Destroy(child.gameObject);
 		}
		//Destroy(transform.Find("someChild").gameObject);
		transform.DetachChildren();
		gameManager = GameObject.Find ("GameManager").GetComponent<GameManager> ();
		superChargedScript = FindObjectOfType<SuperCharged>();
		playerControlScript = FindObjectOfType<PlayerController>();
		ghostWoo = GameObject.Find("SOUND").GetComponent<AudioSource>();
	}

	void Update () {
		

		body2d.velocity = new Vector2 (-moveSpeedX + blastSpeedX, body2d.velocity.y + blastSpeedY);

	}

	public void Restart(){
		//gameManager.currentScore += 1;
		transform.DetachChildren();
		var renderer = GetComponent<SpriteRenderer> ();
		renderer.sprite = sprites [Random.Range (0, sprites.Length)];

		//var collider = GetComponent<BoxCollider2D> ();
		//var size = renderer.bounds.size;
		//size.y += colliderOffset.y;

		blastSpeedX = 0;
		blastSpeedY = 0;

		//collider.size = size;
		//collider.offset = new Vector2 (-colliderOffset.x, collider.size.y / 2 - colliderOffset.y);

	}

	public void Shutdown(){

	}

	void OnCollisionStay2D (Collision2D col)
	{

		if (col.gameObject.tag == "Player") 
		{
			if (superChargedScript.superCharged == true && playerControlScript.facingRight == true) {
				Debug.Log ("super colliding GHOSTLY Right!");
				blastSpeedX += blastX;
				blastSpeedY += blastY;
				ghostWoo.Play();
			}

			else if (superChargedScript.superCharged == true && playerControlScript.facingRight == false) {
				Debug.Log ("super colliding GHOSTLY Left!");
				//blastSpeedX -= (blastX + moveSpeedX);
				//blastSpeedY += blastY;
				ghostWoo.Play();
			}

		
			else {
			Debug.Log ("colliding!");
			}

			//Destroy(col.gameObject);
		}

			else if (col.gameObject.tag == "Babies") {
			col.transform.parent = transform;
			blastSpeedY += blastUpY;
			gameManager.lives -= 1;
		//col.parent = body2d;
		//col.transform.SetParent(gameObject);
			Debug.Log("ghost got a baby");
			} 

				//if (col.gameObject.tag == "Obstacle") {

				//}

		else 
		{
		}
	}



		
}
